-- functions
function CleanUI_OnLoad(self)
    CleanUI_InitDefaultSettings();
    
    -- remove 'Created by'
    -- remove Socketable
    ITEM_CREATED_BY = "";
    ITEM_SOCKETABLE = "";
    
    -- hook methods
    hooksecurefunc(StaticPopupDialogs["DELETE_GOOD_ITEM"], "OnShow", function(s) s.editBox:SetText(DELETE_ITEM_CONFIRM_STRING.."?"); end);

    -- flash Mac-OSX Dock icon or Windows-Taskbar icon
    hooksecurefunc("StaticPopup_Show", FlashClientIcon);

    -- fix for 'forbidden' message popup
    hooksecurefunc("StaticPopup_Show", function(which)
        if(which == "ADDON_ACTION_FORBIDDEN") then
            StaticPopup_Hide(which);
        end
    end);

    -- send messages
    C_ChatInfo.RegisterAddonMessagePrefix("CUI_SEND_FP");

    -- scale errors frame
    ScriptErrorsFrame:SetScale(0.75);

    -- events
    self:RegisterEvent("PLAYER_ENTERING_WORLD");
    self:RegisterEvent("ADDON_LOADED");
    --self:RegisterEvent("CVAR_UPDATE");
    self:RegisterEvent("READY_CHECK");
    self:RegisterEvent("PLAYER_MONEY");
    self:RegisterEvent("PLAYER_LEVEL_UP");
    
    self:RegisterEvent("TALKINGHEAD_REQUESTED");
    
    -- temp fixes
    SetCVar("floatingCombatTextCombatHealing", 1);
    SetCVar("floatingCombatTextCombatDamage", 1);
    
    SetCVar("nameplateMaxDistance", 40);
    SetCVar("nameplateOtherTopInset", -1);
    SetCVar("nameplateOtherBottomInset", -1);
    
    -- nameplate fix
    C_NamePlate.SetNamePlateSelfClickThrough(true);

    -- StreamingIcon position fix

    StreamingIcon:ClearAllPoints();
    StreamingIcon:SetPoint("TOP", UIParent, "TOP", 0, -65);
    
    -- camera fix
    --SetCVar("cameraDistanceMaxFactor", 2.6);
    
    -- frame position fix
    --WorldQuestCompleteAlertFrame:ClearAllPoints();
    --WorldQuestCompleteAlertFrame:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, 200);
    
    -- chat commands
    CleanUI_InitSlashCommandHandler();
    
    -- MouseFixes
    DeathKnightResourceOverlayFrame:EnableMouse(false);
    for i = 1, #DeathKnightResourceOverlayFrame.Runes do
        DeathKnightResourceOverlayFrame.Runes[i]:EnableMouse(false);
    end
    
    ClassNameplateBarMageFrame:EnableMouse(false);
    for i = 1, #ClassNameplateBarMageFrame.Charges do
        ClassNameplateBarMageFrame.Charges[i]:EnableMouse(false);
    end
    
    ClassNameplateBarWindwalkerMonkFrame:EnableMouse(false);
    for i = 1, #ClassNameplateBarWindwalkerMonkFrame.Chi do
        ClassNameplateBarWindwalkerMonkFrame.Chi[i]:EnableMouse(false);
    end
    
    ClassNameplateBarPaladinFrame:EnableMouse(false);
    for i = 1, #ClassNameplateBarPaladinFrame.Runes do
        ClassNameplateBarPaladinFrame.Runes[i]:EnableMouse(false);
    end
    
    ClassNameplateBarRogueDruidFrame:EnableMouse(false);
    for i = 1, #ClassNameplateBarRogueDruidFrame.ComboPoints do
        ClassNameplateBarRogueDruidFrame.ComboPoints[i]:EnableMouse(false);
    end
    
    ClassNameplateBarWarlockFrame:EnableMouse(false);
    for i = 1, #ClassNameplateBarWarlockFrame.Shards do
        ClassNameplateBarWarlockFrame.Shards[i]:EnableMouse(false);
    end
    
    ClassNameplateBarWarlockFrame:EnableMouse(false);
    for i = 1, #ClassNameplateBarWarlockFrame.Shards do
        ClassNameplateBarWarlockFrame.Shards[i]:EnableMouse(false);
    end

    CleanUI_InitLootFrame();
end

function CleanUI_InitLootFrame()

    CleanUI_RemoveTextures(LootFrame);
    CleanUI_RemoveTextures(LootFrame.NineSlice);
    CleanUI_RemoveTextures(LootFrameInset);

    LootFrame.CloseButton:ClearAllPoints();
    LootFrame.CloseButton:SetPoint("BOTTOMRIGHT", LootFrameInset, "TOPRIGHT", 5, 0);
    LootFrame.TitleText:ClearAllPoints();
    LootFrame.TitleText:SetPoint("BOTTOM", LootFrameInset, "TOP", 0, 2);
    LootFrame.TitleText:SetText(ITEMS);

    LootFramePortraitOverlay:Hide();

    local region = CleanUI_GetRegionOfTypeAtPos(LootFrame, "FontString", 1);
    if (region) then
        region:Hide();
    end

    CleanUI_SetArtBackdrop(LootFrame, -30, -3);
end

function CleanUI_InitDefaultSettings()
    -- per account data
    CleanUISavedVariables = CleanUISavedVariables or {};
    CleanUIAccountData = CleanUIAccountData or {};
    CleanUICurrency = CleanUICurrency or {};
    
    -- per char data
    CleanUIUserData = CleanUIUserData or CleanUserData or {};
    CleanUIContainerLock = CleanUIContainerLock or {};
    CleanUIContainerSpecialQuestItems = CleanUIContainerSpecialQuestItems or {};

    CleanUIUserData.appearance = "GENERICWOW";
    
    -- Item buttons
    if (CleanUISavedVariables.ItemButtons == nil) then
        CleanUISavedVariables.ItemButtons = true;
    end
end

function CleanUI_InitSlashCommandHandler()
    SLASH_CLEANUI1 = "/cui";
    SLASH_CLEANUI2 = "/cleanui";
    SlashCmdList["CLEANUI"] = function(msg)
        CleanUI_SlashCommandHandler(msg);
    end
end

function CleanUI_SlashCommandHandler(msg)
    if (msg == "reload") then
        ReloadUI();
    elseif (msg == "reset") then
        CleanUI_ResetSettings();
    elseif (msg == "reset scale") then
        CleanUI_ResetScale();
    elseif (msg == "config") then
        CleanUI_OpenConfig();
    elseif (msg == "gc") then
        CleanUI_GC();
    elseif (msg == "build") then
        CleanUI_WoWBuildInfo();
    elseif (string.find(msg, "set ItemButtons") == 1) then
        local str_ids = string.sub(msg, 17);
        
        if (str_ids == "default") then
            CleanUIUserData.hideItemButtons = false;
            str_ids = "142542,140192,0,147707,140587";
        end
        
        CleanUIUserData.ItemButtonIDs = str_ids;
        CleanUI_CreateItemButtons();
        
        cui_info("ItemButtons set to "..str_ids);
    elseif (msg == "toggle ItemButtons") then
        if (CleanUIUserData.hideItemButtons) then
            CleanUIUserData.hideItemButtons = false;
            cui_info("ItemButtons shown");
        else
            CleanUIUserData.hideItemButtons = true;
            cui_info("ItemButtons hidden");
        end
    elseif (string.find(msg, "dragon") == 1) then
        local str_id = string.sub(msg, 8);
        local id = tonumber(str_id);
        CleanUI_SetUnitFrameDragon(id);
    elseif (string.find(msg, "toggle dragoncolor") == 1) then
        CleanUI_SetUnitFrameColoredDragon(not CleanUIUserData.coloredDragon);
    elseif (string.find(msg, "scale UnitFrames") == 1) then
        local str_scale = string.sub(msg, 18);
        local scale = tonumber(str_scale);
        CleanUI_SetUnitFramesScale(scale);
    elseif (string.find(msg, "scale PartyFrames") == 1) then
        local str_scale = string.sub(msg, 19);
        local scale = tonumber(str_scale);
        CleanUI_SetPartyScale(scale);
    elseif (string.find(msg, "scale MiniMap") == 1) then
        local str_scale = string.sub(msg, 15);
        local scale = tonumber(str_scale);
        CleanUI_SetMiniMapScale(scale);
    elseif (string.find(msg, "scale Map") == 1) then
        local str_scale = string.sub(msg, 11);
        local scale = tonumber(str_scale);
        CleanUI_SetMapScale(scale);
    elseif (string.find(msg, "toggle cursor") == 1) then
        if (CleanUISavedVariables.noCursorFlash) then
            CleanUISavedVariables.noCursorFlash = false;
            cui_info("cursor flash enabled");
        else
            CleanUISavedVariables.noCursorFlash = true;
            cui_info("cursor flash disabled");
        end
    elseif (string.find(msg, "toggle gc") == 1) then
        if (CleanUISavedVariables.CASTINGBARS_GLOBALCOOLDOWN) then
            CleanUISavedVariables.CASTINGBARS_GLOBALCOOLDOWN = false;
            cui_info("global cooldown disabled");
        else
            CleanUISavedVariables.CASTINGBARS_GLOBALCOOLDOWN = true;
            cui_info("global cooldown enabled");
        end
    elseif (string.find(msg, "toggle latency") == 1) then
        if (CleanUISavedVariables.CASTINGBARS_LATENCY) then
            CleanUISavedVariables.CASTINGBARS_LATENCY = false;
            cui_info("latency disabled");
        else
            CleanUISavedVariables.CASTINGBARS_LATENCY = true;
            cui_info("latency enabled");
        end
    elseif (msg == "reset money") then
        CleanUI_ResetMoney();
    else
        CleanUI_ShowHelp()
    end
end

function CleanUI_OpenConfig()
    PlaySound(SOUNDKIT.IG_MAINMENU_OPEN);
    ShowUIPanel(InterfaceOptionsFrame);
    InterfaceOptionsFrame_OpenToCategory(CUIConfigFrame);
    InterfaceOptionsFrame.lastFrame = GameMenuFrame;
end

-- functions
function cui_help_title(value)
    DEFAULT_CHAT_FRAME:AddMessage("|c111155ff"..value.."|r", 1.0, 1.0, 1.0, 1, 10);
end

function cui_help(value, name)
    DEFAULT_CHAT_FRAME:AddMessage("|c333399ff"..value.."|r   "..(name or "nil"), 1.0, 1.0, 1.0, 1, 10);
end

function CleanUI_ShowHelp()
    cui_help_title("==================");
    cui_help_title("CleanUI chat commands:")
    cui_help_title("==================");
    cui_help_title("=== COMMON ===")
    cui_help("/cui config", "open config dialog")
    cui_help("/cui reload", "reload ui")
    cui_help("/cui reset", "reset CleanUI")
    cui_help("/cui reset scale", "reset scale of UI components")
    cui_help("/cui gc", "run blizz garbage colletion")
    cui_help("/cui build", "show wow build info")
    cui_help_title("=== STYLE ===")
    cui_help("/cui dragon #", "dragon style 0 - 3")
    cui_help("/cui toggle dragoncolor")
    cui_help_title("=== SCALE ===")
    cui_help("/cui scale UnitFrames #", "scale unit frames")
    cui_help("/cui scale PartyFrames #", "scale party unit frames")
    cui_help("/cui scale MiniMap #", "scale mini map")
    cui_help_title("=== ITEM BUTTONS ===")
    cui_help("[ctrl] + rightclick", "itembutton context menu for additional config")
    cui_help("/cui toggle ItemButtons", "enable/disable item buttons")
    cui_help("/cui set ItemButtons ###,###,###,###", "set all the casts for the item buttons (comma separated list of item-ids, use 0 as separator)")
    cui_help_title("=== ENABLE/DISABLE ===")
    cui_help("/cui toggle cursor", "enable/disable cursor flash")
    cui_help("/cui toggle gc", "enable/disable global cooldown casting bar")
    cui_help("/cui toggle latency", "enable/disable latency in casting bar")
    cui_help("/cui toggle petbar", "enable/disable pet casting bar")
    cui_help_title("=== OTHER ===")
    cui_help("/cui reset money", "reset money overview")
    cui_help_title("==================");
end

function CleanUI_ResetScale()
    CleanUI_SetUnitFramesScale(1.4);
    CleanUI_SetPartyScale(1.4);
    CleanUI_SetMiniMapScale(1.25);
    CleanUI_SetMapScale(0.85);
end

function CleanUI_ResetSettings()
    CleanUI_ResetScale();
    
    CleanUI_SetUnitFrameDragon(2);
    CleanUI_SetUnitFrameColoredDragon(true);
    
    CleanUISavedVariables.noCursorFlash = false;
    CleanUISavedVariables.showComboPointsGlow = true;

    CleanUISavedVariables.collectMinimapButtons = false;
    
    CleanUISavedVariables.CASTINGBARS_GLOBALCOOLDOWN = true;
    CleanUISavedVariables.CASTINGBARS_LATENCY = true;
    
    CleanUIUserData.hideItemButtons = false;
    CleanUIUserData.ItemButtonIDs = "142542,140192,0,147707,140587";
    CleanUI_CreateItemButtons();
end

function CleanUI_OnEvent(self, event, ...)

    --cui_debug("event", event);

    if (event == "ADDON_LOADED") then
        local addonName = ...;

        if (addonName == "CleanUI") then
            CleanUI_InitCommon();
        end
    end

    if (event == "CVAR_UPDATE") then
        local cvar, value = ...;
        --cui_debug(cvar, value);
    end
    
    -- flash Mac-OSX Dock Icon or Windows-Taskbar Icon
    if (event == "READY_CHECK") then
        FlashClientIcon();
    end
    
    if (event == "PLAYER_MONEY" or event == "PLAYER_ENTERING_WORLD") then
        CleanUI_UpdateMoney();
    end
    
    if (event == "PLAYER_ENTERING_WORLD") then
        CleanUI_UpdateAccountData(); 
    end
    
    if (event == "PLAYER_LEVEL_UP") then
        CleanUI_UpdateAccountData();
    end
    
    if (event == "TALKINGHEAD_REQUESTED") then
        CleanUI_HookTalkingHead();
    end
end

local hooked = false;
function CleanUI_HookTalkingHead()
    if (hooked) then
        return;
    end
    
    if (TalkingHeadFrame) then
        TalkingHeadFrame:HookScript("OnShow", CleanUI_TalkingHeadOnShow);
        CleanUI_TalkingHeadOnShow()
    end
end

function CleanUI_TalkingHeadOnShow()
    TalkingHeadFrame:EnableMouse(false);
end

function CleanUI_InitCommon()
    local delay = 0.1;
    
    CleanUI_StartDelay(delay, CleanUI_InitActionBars); 
    CleanUI_StartDelay(delay, CleanUI_InitAuctions); 
    CleanUI_StartDelay(delay, CleanUI_InitBags);
    CleanUI_StartDelay(delay, CleanUI_InitCastingBars); 
    CleanUI_StartDelay(delay, CleanUI_InitChat);
    CleanUI_StartDelay(delay, CleanUI_InitCharacterFrame);
    CleanUI_StartDelay(delay, CleanUI_InitEquipmentSets);
    CleanUI_StartDelay(delay, CleanUI_InitGameMenu);
    CleanUI_StartDelay(delay, CleanUI_InitMicroButtons);
    CleanUI_StartDelay(delay, CleanUI_InitDeBuffs); 
    CleanUI_StartDelay(delay, CleanUI_InitTalents); 
    CleanUI_StartDelay(delay, CleanUI_InitTooltips); 
    CleanUI_StartDelay(delay, CleanUI_InitMail);
    CleanUI_StartDelay(delay, CleanUI_InitMap);
    CleanUI_StartDelay(delay, CleanUI_InitMiniMap);
    CleanUI_StartDelay(delay, CleanUI_InitOrderHall);
    CleanUI_StartDelay(delay, CleanUI_InitUnitFrames);
    CleanUI_StartDelay(delay, CleanUI_InitObjectiveTracker);
    CleanUI_StartDelay(delay, CleanUI_InitPets);
    CleanUI_StartDelay(delay, CleanUI_InitRangePointer);
    CleanUI_StartDelay(delay, CleanUI_InitWardrobe);
end
