
function CleanUI_InitTooltips()
    CleanUI_TooltipsHookEvents();
    CleanUI_RegisterTooltipsEvents();
end

function CleanUI_TooltipsHookEvents()
    GameTooltip:HookScript("OnShow", CleanUI_TooltipsOnShow);
    GameTooltip:HookScript("OnTooltipSetUnit", CleanUI_OnTooltipSetUnit);
    GameTooltip:HookScript("OnTooltipSetItem", CleanUI_OnTooltipSetItem);
    GameTooltip:HookScript("OnTooltipSetSpell", CleanUI_OnTooltipSetSpell);

    --hooksecurefunc(GameTooltip, "SetAction", CleanUI_SetAction);
    hooksecurefunc("BattlePetToolTip_Show", CleanUI_BattlePetToolTip_Show);

end

function CleanUI_SetAction(action)
    for index,value in pairs(action) do 
        DEFAULT_CHAT_FRAME:AddMessage(tostring(index).." >>>>> "..tostring(value))
      end
end

function CleanUI_RegisterTooltipsEvents()
    local frame = CreateFrame("Frame");

    --frame:RegisterEvent("ADDON_LOADED");

    frame:HookScript("OnEvent", CleanUI_TooltipsOnEvent);
end

function CleanUI_TooltipsOnEvent(self, event, ...)

    --[[if (event == "ADDON_LOADED") then
        local addonName = ...;
        if ( addonName == "..." ) then
        end
    end]]
end

function CleanUI_BattlePetToolTip_Show(speciesID)
	if (speciesID and speciesID > 0) then
        CleanUI_SetBackdrop(BattlePetTooltip, true);
        --BattlePetTooltip:SetBackdropBorderColor(0.0, 0.0, 0.0, 1.0);
        BattlePetTooltip.BorderTopLeft:Hide();
        BattlePetTooltip.BorderTopRight:Hide();
        BattlePetTooltip.BorderBottomRight:Hide();
        BattlePetTooltip.BorderBottomLeft:Hide();
        BattlePetTooltip.BorderTop:Hide();
        BattlePetTooltip.BorderRight:Hide();
        BattlePetTooltip.BorderBottom:Hide();
        BattlePetTooltip.BorderLeft:Hide();
        BattlePetTooltip.Background:Hide();
    end
end

function CleanUI_TooltipsOnShow(self,...)
    if (GameTooltip:GetItem()) then
    elseif (GameTooltip:GetSpell()) then
    elseif (GameTooltip:GetUnit()) then
    else
        CleanUI_SetBackdrop(GameTooltip, true);
        GameTooltip:SetBackdropBorderColor(0.0, 0.0, 0.0, 1.0);
    end
end

function CleanUI_OnTooltipSetUnit(self)
    local unit =  GameTooltip:GetUnit();

    local class = select(2, UnitClass("mouseover" ));
    local r, g, b = GetClassColor(class);

    CleanUI_SetBackdrop(GameTooltip, true);
    GameTooltip:SetBackdropBorderColor(r, g, b, 1.0);
end

function CleanUI_OnTooltipSetItem(self)
    local item = GameTooltip:GetItem();

    if (item) then
        local _, _, quality = GetItemInfo(item);

        local r, g, b = 0.0, 0.0, 0.0;

        if (quality) then
            r, g, b = GetItemQualityColor(quality);
        end

        CleanUI_SetBackdrop(GameTooltip, true);
        GameTooltip:SetBackdropBorderColor(r, g, b, 1.0);
    end
end

function CleanUI_OnTooltipSetSpell(self)
    local spell = GameTooltip:GetSpell();

    CleanUI_SetBackdrop(GameTooltip, true);
    GameTooltip:SetBackdropBorderColor(0.0, 0.0, 0.0, 1.0);
end